# -*- coding: utf-8 -*-
"""
/***************************************************************************
 QollabDialog
                                 A QGIS plugin
 Collaborative analysis with QGIS.
 Generated by Plugin Builder: http://g-sherman.github.io/Qgis-Plugin-Builder/
                             -------------------
        begin                : 2023-08-30
        git sha              : $Format:%H$
        copyright            : (C) 2023 by Sebastian Mikolka-Flöry / TU Wien
        email                : sebastian.floery@geo.tuwien.ac.at
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
"""

import os

from qgis.PyQt import uic
from qgis.PyQt import QtWidgets
from qgis.PyQt import QtCore

# This loads your .ui file so that PyQt can populate your plugin with the elements from Qt Designer
FORM_CLASS, _ = uic.loadUiType(os.path.join(
    os.path.dirname(__file__), 'qollabeo_dialog_base.ui'))


class QollabEODialog(QtWidgets.QDialog, FORM_CLASS):
    
    #added to send custon closed signal when X button in dialog pressed
    closed = QtCore.pyqtSignal()
    
    qtsig_connected = QtCore.pyqtSignal()    
    qtsig_error = QtCore.pyqtSignal()

    qtsig_created = QtCore.pyqtSignal(object)
    qtsig_started = QtCore.pyqtSignal(object)
    qtsig_joined = QtCore.pyqtSignal(object)
    qtsig_entered = QtCore.pyqtSignal(object)
    
    qtsig_user_list = QtCore.pyqtSignal(object)
    qtsig_room_left = QtCore.pyqtSignal(object)
    qtsig_room_closed = QtCore.pyqtSignal()
    
    qtsig_extent = QtCore.pyqtSignal(object)
    qtsig_crs = QtCore.pyqtSignal(object)
    qtsig_vis_changed = QtCore.pyqtSignal(object)
    qtsig_lyr_added = QtCore.pyqtSignal(object)
    qtsig_lyr_removed = QtCore.pyqtSignal(object)
    
    qtsig_feat_added = QtCore.pyqtSignal(object)
        
    def __init__(self, parent=None):
        """Constructor."""
        super(QollabEODialog, self).__init__(parent)
        # Set up the user interface from Designer through FORM_CLASS.
        # After self.setupUi() you can access any designer object by doing
        # self.<objectname>, and you can use autoconnect slots - see
        # http://qt-project.org/doc/qt-4.8/designer-using-a-ui-file.html
        # #widgets-and-dialogs-with-auto-connect
        self.setupUi(self)

    #overriding dialogs close event to catch the signal in the plugin itself;
    def closeEvent(self, event):
        super(QollabEODialog, self).closeEvent(event)
        self.closed.emit()